<script setup lang="ts">
  /* eslint-disable */
  import { ToastConfig } from '~/composables/layout/useToasts';

  const options = [
    { id: 1, name: 'Wade Cooper' },
    { id: 2, name: 'Arlene Mccoy' },
    { id: 3, name: 'Devon Webb' },
    { id: 4, name: 'Tom Cook' },
    { id: 5, name: 'Tanya Fox' },
    { id: 6, name: 'Hellen Schmidt' },
    { id: 7, name: 'Caroline Schultz' },
    { id: 8, name: 'Mason Heaney' },
    { id: 9, name: 'Claudie Smitham' },
    { id: 10, name: 'Emil Schaefer' },
  ];

  const images = [
    'https://images.pexels.com/photos/674010/pexels-photo-674010.jpeg?cs=srgb&dl=pexels-anjana-c-674010.jpg&fm=jpg',
    'https://wallpapers.com/images/featured/beautiful-3vau5vtfa3qn7k8v.jpg',
    'https://i.pinimg.com/474x/6c/12/fd/6c12fdc402726c513901a61f512ba3c6.jpg',
    'https://images.pexels.com/photos/794494/pexels-photo-794494.jpeg?cs=srgb&dl=pexels-anthony-%F0%9F%93%B7%F0%9F%93%B9%F0%9F%99%82-794494.jpg&fm=jpg',
    'https://cdn.wallpapersafari.com/16/69/rcj6Cz.jpg',
    'https://images.pexels.com/photos/674010/pexels-photo-674010.jpeg?cs=srgb&dl=pexels-anjana-c-674010.jpg&fm=jpg',
    'https://wallpapers.com/images/featured/beautiful-3vau5vtfa3qn7k8v.jpg',
    'https://i.pinimg.com/474x/6c/12/fd/6c12fdc402726c513901a61f512ba3c6.jpg',
    'https://images.pexels.com/photos/794494/pexels-photo-794494.jpeg?cs=srgb&dl=pexels-anthony-%F0%9F%93%B7%F0%9F%93%B9%F0%9F%99%82-794494.jpg&fm=jpg',
    'https://cdn.wallpapersafari.com/16/69/rcj6Cz.jpg',
  ];

  const selected1 = ref();
  const selected2 = ref();
  const selected3 = ref();
  const selected4 = ref();

  const controller = useModal();
  const leftSidebarController = useModal();
  const rightSidebarController = useModal();
  const toastsCtx = useToasts();

  let num = 0;
  function createToast() {
    const toastConfig: Partial<ToastConfig>[] = [
      {},
      { variant: 'info' },
      { variant: 'success' },
      { variant: 'error' },
    ];

    const selectedConfig = toastConfig[num % toastConfig.length];

    toastsCtx.createToast({
      content: 'Lorem ipsum dolor.' + num,
      variant: selectedConfig.variant,
      actionText: 'Action',
      actionFn: () => console.log(123),
      showCloseBtn: false,
    });
    num++;
  }

  const productList = ref([
    {
      id: 0,
      name: 'Guide tool: no quick view or detail page link.',
      price: '$1*',
      loading: true,
    },
    {
      id: 1,
      name: 'Guide tool: no quick view or detail page link.',
      price: '$1*',
      mode: 'guideTool',
    },
    {
      id: 2,
      name: 'Participant: Image + title = Quick view.',
      price: '$2*',
      productReviews: 2,
      mode: 'participant',
    },
    {
      id: 3,
      name: 'Guide + “All participants” selected: Image + title = Detail page',
      price: '$3*',
      ratingAverage: 2,
      sales: 3,
      mode: 'selected',
    },
    {
      id: 5,
      name: 'Unguided Participant  + Guide acting for participant: Image + title = Detail page, Eye button = quick view',
      price: '$4*',
      properties: { size: 34, color: 'red' },
      mode: 'unguided',
    },
    {
      id: 7,
      name: 'Product card in watch list, Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industrys standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries ',
      price: '$5*',
      isWatchList: true,
    },
    {
      id: 8,
      name: 'Product card in favorite list',
      price: '$18*',
      removable: true,
    },
  ]);

  const isLoadingMore = ref(false);
  const loadMoreProduct = () => {
    console.log('loadMoreProduct');
    isLoadingMore.value = true;
    setTimeout(() => {
      isLoadingMore.value = false;
      productList.value.push(...productList.value);
    }, 2000);
  };

  const tabs = ['Description', 'Reviews'];
</script>

<template>
  <div class="relative gap-8">
    <!-- Left Sidebar -->
    <SwSidebar
      position="left"
      class="w-100vw sm:w-80"
      @close="leftSidebarController.close"
    >
      <template #header>New Headline</template>

      <template #body>
        <div class="flex flex-col bg-white px-6">
          <div v-for="i in 40" :key="i" class="">New content {{ i }}</div>
        </div>
      </template>

      <template #footer>
        <div
          class="shadow-5 flex w-full items-center justify-between border-t border-gray-400 bg-gray-50 p-5"
        >
          <p>
            <span class="font-bold">Notes</span>
            <span class="text-darkgray-900"> (3)</span>
          </p>

          <SwButton variant="action">
            <p>Show</p>
            <span class="i-sw-solid-cog text-base"></span>
          </SwButton>
        </div>

        <div
          class="shadow-5 flex w-full items-center justify-between border-t border-gray-400 bg-gray-50 p-5"
        >
          <p>
            <span class="font-bold">Notes</span>
            <span class="text-darkgray-900"> (3)</span>
          </p>

          <SwButton variant="action">
            <p>Show</p>
            <span class="i-sw-solid-cog text-base"></span>
          </SwButton>
        </div>
      </template>
    </SwSidebar>

    <div class="container mx-auto mb-16 mt-5 flex max-w-lg flex-1 flex-col gap-4 lg:mb-[4.5rem]">
      <SwTextField label="111" />

      <SwTextField size="large" label="111" />

      <SwTextField size="small" label="111" />

      <SwToggle />
      <SwToggle>
        <template #label>111</template>
      </SwToggle>
      <SwLink to="http://google.com">test1</SwLink>
      <SwLink to="http://google.com" variant="action">test2</SwLink>
      <SwLink to="http://google.com" variant="danger">test3</SwLink>
      <SwLink to="http://google.com" disabled>test1</SwLink>
      <SwLink to="http://google.com" variant="action" disabled>test2</SwLink>
      <SwLink to="http://google.com" variant="danger" disabled>test3</SwLink>
      <SwBanner type="toast">1111</SwBanner>
      <SwBanner type="toast" variant="warning">1111</SwBanner>
      <SwBanner type="toast" variant="info">1111</SwBanner>
      <SwBanner type="toast" variant="error">1111</SwBanner>
      <SwBanner type="toast" variant="success">1111</SwBanner>
      <SwBanner type="inline">1111</SwBanner>
      <SwBanner type="inline" variant="warning">1111</SwBanner>
      <SwBanner type="inline" variant="info">1111</SwBanner>
      <SwBanner type="inline" variant="error">1111</SwBanner>
      <SwBanner type="inline" variant="success">1111</SwBanner>
      <SwButton variant="action" @click="createToast">Create toast</SwButton>
      <SwBackButton />
      <SwButton variant="danger" size="small">Save</SwButton>
      <SwButton variant="primary">Save</SwButton>
      <SwButton variant="action">Save</SwButton>
      <SwButton variant="primary" loading>Save</SwButton>
      <SwButton variant="primary">
        <template #icon>
          <span class="i-sw-solid:cog"></span>
        </template>
        Save
      </SwButton>
      <SwButton variant="primary" badge="200"> test badge </SwButton>
      <SwButton variant="danger-outlined" rounded badge="200">
        <template #icon>
          <span class="i-sw-solid:cog" />
        </template>
      </SwButton>
      <SwButton variant="danger-outlined" rounded disabled>
        <template #icon>
          <span class="i-sw-solid:cog" />
        </template>
      </SwButton>
      <button @click="controller.open">Open modal</button>
      <SwModal :controller="controller" modal-title="Example" backdrop-display="static">
        <template #body>
          <p>content</p>
        </template>
        <template #footer>
          <SwButton variant="action" @click="controller.close">Cancel</SwButton>
          <SwButton>Save</SwButton>
        </template>
      </SwModal>
      <h3>Tooltip:</h3>
      <div class="mx-auto flex flex-col items-center gap-4">
        <SwTooltip content="Tooltip scales" position="top" width="scales">
          <SwButton class="w-50">Hover me!</SwButton>
        </SwTooltip>
        <SwTooltip content="Tooltip max-width" position="bottom">
          <SwButton class="w-50">Hover me</SwButton>
        </SwTooltip>
        <SwTooltip content="Tooltip text" position="right">
          <SwButton class="w-50">Hover me</SwButton>
        </SwTooltip>
        <SwTooltip content="Tooltip text" position="left">
          <SwButton class="w-50">Hover me</SwButton>
        </SwTooltip>
      </div>
      <SwDropdownMenu>
        <template #trigger-button>
          <SwButton>
            test
          </SwButton>
        </template>
        <template #content>
          <span>12312312</span>
        </template>
      </SwDropdownMenu>
      <h2>>Single</h2>
      <SwSelect v-model="selected1" :options="options" placeholder="ABC" label="ABCXYZ"/>
      {{ selected1 }}
      <SwSelect v-model="selected2" :options="options" placeholder="ABC" label="ABCXYZ" return-object-value/>
      {{ selected2 }}

      <h2>Multiple</h2>
      <SwSelect v-model="selected3" :options="options" placeholder="ABC" label="ABCXYZ" multiple />
      {{ selected3 }}
      <SwSelect v-model="selected4" :options="options" placeholder="ABC" label="ABCXYZ" multiple return-object-value/>
      {{ selected4 }}

      <SwButton @click="leftSidebarController.toggle">Open left sidebar</SwButton>

      <SwButton @click="rightSidebarController.toggle">Open right sidebar</SwButton>

      <SwPagination :pageSize="1" :total="7" />
      <SwPagination :pageSize="1" :total="11" />
      <SwPagination :pageSize="1" :total="21" :aroundItems="2" />

      <div class="grid grid-cols-2 grid-rows-4 gap-4">
        <SwDigitalProductCard
          v-for="product in productList"
          :key="product.id"
          :data="product"
          :loading="false"
          :mode="product.mode"
          :isWatchList="product.isWatchList"
          :removable="product.removable"
        />
      </div>

      <SwTab :tabs="tabs" :defaultTabIndex="1">
        <template #tab-0>Content of the first tab</template>
        <template #tab-1>Content of the second tab</template>
      </SwTab>
    </div>

    <!-- Right Sidebar -->
    <SwSidebar
      position="right"
      class="w-100vw sm:w-80"
      @close="rightSidebarController.close"
    >
      <template #headline>New Headline</template>

      <template #body>
        <div class="flex flex-col bg-white px-6">
          <div v-for="i in 40" class="">New content {{ i }}</div>
        </div>
      </template>

      <template #footer>
        <div
          class="shadow-5 flex w-full items-center justify-between border-t border-gray-400 bg-gray-50 p-5"
        >
          <p>
            <span class="font-bold">Notes</span>
            <span class="text-darkgray-900"> (3)</span>
          </p>

          <SwButton variant="action">
            <p>Show</p>
            <span class="i-sw-solid-cog text-base"></span>
          </SwButton>
        </div>

        <div
          class="shadow-5 flex w-full items-center justify-between border-t border-gray-400 bg-gray-50 p-5"
        >
          <p>
            <span class="font-bold">Notes</span>
            <span class="text-darkgray-900"> (3)</span>
          </p>

          <SwButton variant="action">
            <p>Show</p>
            <span class="i-sw-solid-cog text-base"></span>
          </SwButton>
        </div>
      </template>
    </SwSidebar>
    <Toolbar class="fixed bottom-0 left-0 w-full" />

    <div class="mb-25 container mx-auto my-10">
      <SwProductList
        :data="productList"
        scrollLoadMode
        :isLoadingMore="isLoadingMore"
        @load-more="loadMoreProduct"
      >
        <SwDigitalProductCard
          v-for="product in productList"
          :key="product.id"
          :data="product"
          :mode="mode"
        />
      </SwProductList>
    </div>
    <div class="mb-25 container mx-auto my-10">
      <div class="w-[500px]">
        <SwGallery :images="images" />
      </div>
    </div>
    <SwSlider>
      <div v-for="i in 10" :key="i" class="h-100 flex items-center justify-center bg-gray-100">
        {{ i }}
      </div>
    </SwSlider>
  </div>
</template>
